' module: create a crossword puzzle
#include once "include/showWords.bi"

' TODO:
' Ausgrauen gefundener Begriffe


namespace CROSSWORD
  declare function checkPosibility(char() as integer, x as integer, y as integer, direc as integer, txt as wstring ptr) as integer
  declare function findFilling(length() as integer, empty as integer, first as integer = 0) as string
  declare sub getMinMaxPos(byref xMin as integer, byref xMax as integer, byref yMin as integer, byref yMax as integer, _
                           w as integer, h as integer, size as integer, direc as integer)
  declare function getRandomDirec(w as integer, h as integer, size as integer) as integer
  declare sub getRandomPos(byref x as integer, byref y as integer, w as integer, h as integer, size as integer, direc as integer)

  declare function callback(exercise as TExercise) as long
  declare sub mark(gx1 as integer, gx2 as integer, gy1 as integer, gy2 as integer, _
                             startX as integer, startY as integer, boxWidth as integer)

  enum Direction
    rightup = 0, right, rightdown, down
    leftdown, left, leftup, up
    last
  end enum

  type TCWord
    as ubyte x, y, direction, found
    as TWord value
    declare constructor
    declare constructor(x_ as ubyte, y_ as ubyte, d_ as ubyte, v_ as TWord)
    declare operator cast as string
  end type
  operator =(w1 as TCWord, w2 as TCWord) as integer
    return w1.x = w2.x andalso w1.y = w2.y andalso w1.direction = w2.direction
  end operator
  mdListDeclare(TCWord)

  type CROSSWORD.TGrid
    as uinteger w, h, wordcount, char(any, any), used(any, any), empty
    as mdList(TCWord) word, filling
    as mdList(TWord) missing
    declare constructor
    declare constructor(w_ as uinteger, h_ as uinteger)
    declare sub create(wordlist as mdList(TListPoint), byref count_ as uinteger = -1, minLen as integer = 4)
    declare sub add(x as integer, y as integer, direc as integer, wordPtr as wstring ptr, size as integer)
    declare sub exportHtml(filename as string, headline as string, title as string = "")
    declare sub fill overload(list as mdList(TWord))
    declare sub fill(txt as string)
    declare sub fillRandomly
  end type
end namespace

scope
  dim as TList crosswordList
  with crosswordList
    .listName = "crossword"
    .list.addAll(fullList.list)
    .save
    .list.clear
  end with
end scope
globalExercises.add(TExercise("Kreuzwortgitter", "crossword", 0, @CROSSWORD.callback, @infoEmpty, @chooseWords))

constructor CROSSWORD.TCWord
end constructor

constructor CROSSWORD.TCWord(x_ as ubyte, y_ as ubyte, d_ as ubyte, v_ as TWord)
  x         = x_
  y         = y_
  direction = d_
  value     = v_
end constructor

operator CROSSWORD.TCWord.cast as string
  return str(@value)
end operator

constructor CROSSWORD.TGrid
end constructor

constructor CROSSWORD.TGrid(w_ as uinteger, h_ as uinteger)
  w = w_
  h = h_
  redim char(w-1, h-1)
  redim used(w-1, h-1)
  empty = w*h
end constructor

sub CROSSWORD.TGrid.add(x as integer, y as integer, direc as integer, wordPtr as wstring ptr, size as integer)
  dim as integer ret = 0, dx, dy, px = x, py = y, i = 0
  select case direc
    case Direction.rightup   : dx =  1 : dy = -1
    case Direction.right     : dx =  1 : dy =  0
    case Direction.rightdown : dx =  1 : dy =  1
    case Direction.down      : dx =  0 : dy =  1
    case Direction.leftdown  : dx = -1 : dy =  1
    case Direction.left      : dx = -1 : dy =  0
    case Direction.leftup    : dx = -1 : dy = -1
    case Direction.up        : dx =  0 : dy = -1
  end select
  for i as integer = 0 to size-1
    if char(px, py) = 0 then empty -= 1
    char(px, py) = asc(wordPtr[i])
    used(px, py) = -1
    px += dx
    py += dy
  next
end sub

sub CROSSWORD.TGrid.create(wordlist as mdList(TListPoint), byref count_ as uinteger = -1, minLen as integer = 4)
  wordcount = wordlist.size
  if count_ = 0 or wordcount = 0 then exit sub
  dim as integer tempLen, tempInt, direc, x, y, rand, posible, best = -1, xMin, xMax, yMin, yMax, tempSize = 0
  dim as string fillpattern
  dim as wstring ptr wordPtr
  dim as mdList(TWord) tempList
  dim as TWord tempWord
  dim as string backward
  dim as TCWord bestTry, tmpCWord
  ' prepare list of words
  for i as integer = 0 to wordcount-1
    tempWord = globalList.get(wordlist.get(i).id)
    tempWord.word = modifyTxt(tempWord.word, MODIFY_TOUPPER or MODIFY_NOACUTE)
    if len(tempWord.word) < minLen then continue for
    ' add word (randomly mixed)
    rand = int(rnd*(tempSize+1))
    if rand = tempSize then
      tempList.add(tempWord)
    else
      tempList.add(rand, tempWord)
    end if
    tempSize += 1
  next
  ' add words
  do while count_ > 0
    best = -1
    tempWord = tempList.get(0)
    tempList.remove(0)
    ' exclude words with forbitten chars words that are part of other words
    backward = space(len(tempWord.word))
    for i as integer = 0 to len(tempWord.word)-1
      ' only ASCII and Ñ allowed
      if tempWord.word[i] = 192 then
        if len(tempWord.word) = i-1 orelse tempWord.word[i+1] <> 145 then continue do
      else
        if tempWord.word[i] < 65 or tempWord.word[i] > 90 then continue do
      end if
      backward[len(tempWord.word)-i-1] = tempWord.word[i]
    next
    foreach(TCWord, tmpCWord, word)
      if instr(tmpCWord.value.word, tempWord.word) or instr(tempWord.word, tmpCWord.value.word) then continue do
      if instr(tmpCWord.value.word, backward) or instr(backward, tmpCWord.value.word) then continue do
    nexteach
    ' WSTRING of the word
    tempLen = wordLength(tempWord.word)
    if tempLen = 0 then exit do
    wordPtr = callocate((tempLen+1)*sizeof(wstring))
    UTFToWChar(UTF_ENCOD_UTF8, strptr(tempWord.word), wordPtr, @tempLen)
    ' choose a position in the grid
    if tempLen <= w and tempLen <= h then
      for direc = 0 to Direction.last-1
        if w < tempLen andalso direc <> Direction.up and direc <> Direction.down then continue for
        if h < tempLen andalso direc <> Direction.left and direc <> Direction.right then continue for
        getMinMaxPos xMin, xMax, yMin, yMax, w, h, tempLen, direc
        for x as integer = xMin to xMax
          for y as integer = yMin to yMax
            posible = checkPosibility(char(), x, y, direc, wordPtr)
            if posible >= 0 then posible = 100*posible + int(rnd*999)
            if posible > best then
              bestTry = TCWord(x, y, direc, TWord)
              best = posible
            end if
          next
        next
      next
      if best >= 0 then
        add bestTry.x, bestTry.y, bestTry.direction, wordPtr, tempLen
        word.add TCWord(bestTry.x, bestTry.y, bestTry.direction, tempWord)
      else
        missing.add tempWord
      end if
    end if
    deallocate wordPtr
  loop
end sub

sub CROSSWORD.TGrid.exportHtml(filename as string, headline as string, title as string = "")
  ' export grid to a HTML file
  dim as TCWord tempWord
  dim zPtr as zstring ptr = allocate(2*sizeof(wstring)), wPtr as wstring ptr = allocate(3*sizeof(zstring))
  dim as integer size, filenumber = freefile
  open filename for output as filenumber
  print #filenumber, "<!DOCTYPE html>"
  print #filenumber, !"<html>\n"
  print #filenumber, "<head>"
  print #filenumber, "<title>Lengua - " & iif(len(title), title, headline) & "</title>"
  print #filenumber, "<meta http-equiv=""content-type"" content=""text/html;charset=utf-8"" />"
  print #filenumber, "<style>"
  print #filenumber, "  td.g {border:1px black solid; text-align:center; width:2em; height:2em;}"
  print #filenumber, "</style>"
  print #filenumber, !"</head>\n"
  print #filenumber, "<body>"
  print #filenumber, "  <h1>" & headline & "</h1>"
  print #filenumber, "  <table style=""border-collapse:collapse;"">"
  for y as integer = 0 to h-1
    print #filenumber, !"  <tr>\n    ";
    for x as integer = 0 to w-1
      *wPtr = wchr(char(x, y), 0)
      *zPtr = chr(0, 0, 0)
      WCharToUTF(UTF_ENCOD_UTF8, wPtr, 1, zPtr, @size)
      print #filenumber, "<td class=""g"">" & *zPtr & "</td>";
    next
    if y = 0 then
      print #filenumber, !"\n    <td rowspan=""" & h+1 & !""" style=""padding-left:5em;"">\n      ";
      foreach(TCWord, tempWord, word)
        print #filenumber, tempWord.value.translate.get(0) & "<br />";
      nexteach
      print #filenumber, !"\n    </td>";
    end if
    print #filenumber, !"\n  </tr>"
  next
  print #filenumber, "   <tr><td>&nbsp;</td></tr>"
  print #filenumber, "  </table>"
  print #filenumber, "</body>"
  print #filenumber, "</html>"
  close filenumber
  deallocate wPtr
  deallocate zPtr
end sub

sub CROSSWORD.TGrid.fill(list as mdList(TWord))
  ' fill empty spaces with words from the list
  if list.isEmpty then exit sub
  dim as integer tempInt = 0, tempLen, length(list.size-1)
  dim tempWord as TWord, fillpattern as string, wordPtr as wstring ptr
  foreach(TWord, tempWord, list)
    length(tempInt) = wordLength(tempWord.word)
    tempInt += 1
  nexteach
  fillpattern = findFilling(length(), empty)
  dim as integer i = 0
  tempLen = 0
  tempInt = 1
  wordPtr = 0
  for y as integer = 0 to h-1
    for x as integer = 0 to w-1
      if char(x, y) = 0 then
        ' check whether the next word has to be choosen
        if tempInt > tempLen then
          if wordPtr then deallocate wordPtr
          i += 1
          if i >= len(fillpattern) then exit for, for
          tempWord = list.get(fillpattern[i])
          filling.add(TCWord(x, y, -1, tempWord))
          list.remove(tempWord)
          tempWord.word = modifyTxt(tempWord.word, MODIFY_TOUPPER or MODIFY_NOACUTE)
          tempLen = wordLength(tempWord.word)
          wordPtr = callocate((tempLen+1)*sizeof(wstring))
          UTFToWChar(UTF_ENCOD_UTF8, strptr(tempWord.word), wordPtr, @tempLen)
          tempInt = 1
        end if
        ' insert next char into grid
        char(x, y) = asc(*wordPtr, tempInt)
        tempInt += 1
      end if
    next
  next
end sub

sub CROSSWORD.TGrid.fill(txt as string)
  ' fill empty spaces with given text
  dim as integer i = 0
  for y as integer = 0 to h-1
    for x as integer = 0 to w-1
      if i >= len(txt) then exit for, for
      if char(x, y) = 0 then
        char(x, y) = txt[i]
        i += 1
      end if
    next
  next
end sub

sub CROSSWORD.TGrid.fillRandomly
  ' fill empty spaces with random letters (A-Z only)
  dim as string txt = space(empty)
  for i as integer = 0 to empty-1
    txt[i] = int(rnd*26) + 65
  next
  fill txt
end sub

function CROSSWORD.checkPosibility(char() as integer, x as integer, y as integer, direc as integer, txt as wstring ptr) as integer
  dim as integer ret = 0, dx, dy, px = x, py = y, i = 0
  select case direc
    case Direction.rightup   : dx =  1 : dy = -1 : ret += 1
    case Direction.right     : dx =  1 : dy =  0 : ret += 2
    case Direction.rightdown : dx =  1 : dy =  1 : ret += 1
    case Direction.down      : dx =  0 : dy =  1 : ret += 2
    case Direction.leftdown  : dx = -1 : dy =  1
    case Direction.left      : dx = -1 : dy =  0
    case Direction.leftup    : dx = -1 : dy = -1
    case Direction.up        : dx =  0 : dy = -1
  end select
  do while i < len(*txt)
    if px < lbound(char, 1) or py < lbound(char, 2) or px > ubound(char, 1) or py > ubound(char, 2) then return -1
    if char(px, py) > 0 then
      if char(px, py) = asc(txt[i]) then ret += 100 else return -1
    end if
    i += 1
    px += dx
    py += dy
  loop
  return ret
end function

function CROSSWORD.findFilling(length() as integer, empty as integer, first as integer = 0) as string
  dim as string try, bestTry = chr(empty)
  dim as integer last = iif(ubound(length) > 255, 255, ubound(length)), best = 0
  for i as integer = first to last
    if length(i) > empty then continue for
    if length(i) = empty then return chr(0, i)
    try = findFilling(length(), empty-length(i), i+1)
    if try[0] = 0 then return try & chr(i)
    if try[0] < bestTry[0] then bestTry = try & chr(i)
  next
  return bestTry
end function

sub CROSSWORD.getMinMaxPos(byref xMin as integer, byref xMax as integer, byref yMin as integer, byref yMax as integer, _
                 w as integer, h as integer, size as integer, direc as integer)
  select case direc
    case Direction.leftup, Direction.left, Direction.leftdown    : xMin = size-1
    case else                                                    : xMin = 0
  end select
  select case direc
    case Direction.rightup, Direction.right, Direction.rightdown : xMax = w-size
    case else                                                    : xMax = w-1
  end select
  select case direc
    case Direction.leftup, Direction.up, Direction.rightup       : yMin = size-1
    case else                                                    : yMin = 0
  end select
  select case direc
    case Direction.leftdown, Direction.down, Direction.rightdown : yMax = h-size
    case else                                                    : yMax = h-1
  end select
end sub

function CROSSWORD.getRandomDirec(w as integer, h as integer, size as integer) as integer
  if w < size and h < size then return -1
  if w < size then return iif(rnd < .5, Direction.up, Direction.down)
  if h < size then return iif(rnd < .5, Direction.left, Direction.right)
  return int(rnd*Direction.last)  
end function

sub CROSSWORD.getRandomPos(byref x as integer, byref y as integer, w as integer, h as integer, size as integer, direc as integer)
  dim as integer xMin, xMax, yMin, yMax
  getMinMaxPos xMin, xMax, yMin, yMax, w, h, size, direc
  x = int(rnd*(xMax-xMin+1)) + xMin
  y = int(rnd*(yMax-yMin+1)) + yMin
end sub

function CROSSWORD.callback(exercise as TExercise) as long
  static as integer showTranslations = -1
  enum
    posNone = 0, posSetting, posHelp, posShow, posSolve, posNew, posExport, posExit
  end enum
  dim as integer LBx = 120, LBy = 580, LBw = 110, LBh = 30, LBp = 20
  dim as integer startX = 40, startY = 100, boxWidth = 38, mouseX, mouseY, mouseB, direc, wordLen, oldX, oldY, toFind, tempInt
  dim as integer transStartX = 480, transStartY = 100, transW = 300, transH = 380, transDist = 20
  dim as uinteger gx1, gx2, gy1, gy2
  dim key as string, coord as TCoord
  dim crosswordGui as TGui, event as TGuiEvent
  crosswordGui.buttons.add _
      TGuiButton(posHelp, exepath & "/img/help.bmp", LBx-100, LBy, 40, 40, chr(255, 59), "", GuiState.noBorder)
  crosswordGui.buttons.add _
      TGuiButton(posSetting, exepath & "/img/settings.bmp", LBx-60, LBy, 40, 40, chr(9), "", GuiState.noBorder)
  dim as TGuiButton buttonShow = TGuiButton(posShow, LBx, LBy, LBw, LBh, "Anzeige " & iif(showTranslations, "aus", "an"))
  crosswordGui.buttons.add buttonShow
  crosswordGui.buttons.add _
      TGuiButton(posSolve, LBx+(LBw+LBp), LBy, LBw, LBh, "Lösung")
  crosswordGui.buttons.add _
      TGuiButton(posNew, LBx+(LBw+LBp)*2, LBy, LBw, LBh, "neues Rätsel")
  crosswordGui.buttons.add _
      TGuiButton(posExport, LBx+(LBw+LBp)*3, LBy, LBw, LBh, "HTML-Export")
  crosswordGui.buttons.add _
      TGuiButton(posExit, LBx+(LBw+LBp)*4, LBy, LBw, LBh, "zurück", chr(27))
  
  do
    ' create crossword puzzle
    dim as FB.Image ptr transList = imagecreate(transW, transH+transDist, &hffffff)
    dim as TGrid grid = TGrid(10, 10)
    dim as TCWord wordlist()
    grid.create exercise.currentList.list
    grid.fill grid.missing
    grid.fillRandomly
    grid.word.toArray(wordlist())
    toFind = grid.word.size
    for i as integer = 0 to ubound(wordlist)
      printFT iif(i < transH\transDist, 0, transW\2), _
              iif(i < transH\transDist, i, (i-transH\transDist))*20, _
              wordlist(i).value.translate.get(0), font, 14,, transList
    next
    screenlock
    cls
    printFT 30, 30, "Suchen Sie die spanischen Begriffe, deren Übersetzungen rechts aufgelistet ist.", font
    crosswordGui.show
    select case grid.filling.size
      case 0
      case 1
        printFT 30, 50, "Die restlichen Buchstaben ergeben, der Reihe nach gelesen, ein weiteres Wort.", font
      case else
        printFT 30, 50, "Die restlichen Buchstaben ergeben, der Reihe nach gelesen, " & grid.filling.size & " weitere Wörter.", font
    end select
    for y as integer = 0 to grid.h-1
      for x as integer = 0 to grid.w-1
        line (x*boxWidth+startX, y*boxWidth+startY)-step(boxWidth, boxWidth),, b
        centerFT (x+.5)*boxWidth+startX-1, (y+.5)*boxWidth+startY+2, wchr(grid.char(x, y)), font
      next
    next
    if showTranslations then put (transStartX, transStartY), transList, pset
    screenunlock
    ' solve
    do
      oldX = -1
      ' start and end position of the word
      do
        getmouse mouseX, mouseY,, mouseB
        sleep 1
      loop until mouseB < 1
      ' mark words in the grid
      do
        getmouse mouseX, mouseY,, mouseB
        key = inkey
        sleep 1
      loop until mouseB = 1 orelse len(key)
      if key = chr(255, 107) then exit do
      gx1 = (mouseX-startX) \ boxWidth
      gy1 = (mouseY-startY) \ boxWidth
      ' check GUI
      event = crosswordGui.getEvent(key)
      select case event.id
        case posHelp
          dim as FB.Image ptr tempImg = imagecreate(SCREEN_X, SCREEN_Y)
          get (0, 0)-(SCREEN_X-1, SCREEN_Y-1), tempImg
          help LANGUAGE & "/doc.htm", "crossword"
          put (0, 0), tempImg, pset
          imagedestroy tempImg
        case posSetting
          dim as FB.Image ptr tempImg = imagecreate(SCREEN_X, SCREEN_Y)
          get (0, 0)-(SCREEN_X-1, SCREEN_Y-1), tempImg
          tempInt = chooseWords(exercise)
          if tempInt = RETVAR.windowClosed then key = chr(255, 107)
          put (0, 0), tempImg, pset
          imagedestroy tempImg
        case posShow
          showTranslations = not showTranslations
          if showtranslations then
            put (transStartX, transStartY), transList, pset
            buttonShow.title = "Anzeige aus"
            buttonShow.show
          else
            line (transStartX, transStartY)-step(transW-1, transH-1), &hffffff, bf
            buttonShow.title = "Anzeige an"
            buttonShow.show
          end if
        case posNew
          if toFind <= 0 orelse message("Wollen Sie das alte Rätsel abbrechen?", "Ja|Nein", 2) = 1 then
            imagedestroy transList
            continue do, do
          end if
        case posSolve
          if toFind >= 0 then
            for i as integer = 0 to ubound(wordlist)
              if wordlist(i).found = 0 then
                dim as integer dx = 0, dy = 0, size = wordLength(wordlist(i).value.word)-1
                select case wordlist(i).direction
                  case DIRECTION.leftup, DIRECTION.left, DIRECTION.leftdown
                    dx = -size
                  case DIRECTION.rightup, DIRECTION.right, DIRECTION.rightdown
                    dx = size
                end select
                select case wordlist(i).direction
                  case DIRECTION.leftup, DIRECTION.up, DIRECTION.rightup
                    dy = -size
                  case DIRECTION.leftdown, DIRECTION.down, DIRECTION.rightdown
                    dy = size
                end select
                line ((wordlist(i).x+.5)*boxWidth+startX, (wordlist(i).y+.5)*boxWidth+startY)-step(dx*boxWidth, dy*boxWidth)
                wordlist(i).found = -1
              end if
            next
            toFind = -1
            dim as FB.Image ptr yellow = imagecreate(boxWidth-1, boxWidth-1, &h000077)
            dim tempWord as TCWord, countLetters as integer = 0
            foreach(TCWord, tempWord, grid.filling)
              countLetters += wordLength(tempWord.value.word)
            nexteach
            for y as integer = 0 to grid.w-1
              for x as integer = 0 to grid.h-1
                if countLetters < 1 then exit for, for
                if grid.used(x, y) = 0 then
                  put (startX+x*boxWidth+1, startY+y*boxWidth+1), yellow, xor
                  countLetters -= 1
                end if
              next
            next
            imagedestroy yellow
          end if
        case posExport
          grid.exportHtml(exepath &  "/spanish/export/crossword.htm", "Sopa de letras")
          message("Das Kreuzwortgitter wurde exportiert.")
        case posExit
           if toFind <= 0 orelse message("Wollen Sie abbrechen?", "Ja|Nein", 2) = 1 then exit do
      end select    
      if gx1 > grid.w-1 or gy1 > grid.h-1 then continue do
      ' release button in grid
      do
        getmouse mouseX, mouseY,, mouseB
        key = inkey
        if key = chr(255, 107) orelse _
                 (key = chr(27) andalso (toFind <= 0 orelse message("Wollen Sie abbrechen?", "Ja|Nein", 2) = 1)) then exit do, do
        gx2 = (mouseX-startX) \ boxWidth
        gy2 = (mouseY-startY) \ boxWidth
        if gx2 <> oldX or gy2 <> oldY then
          if oldX >= 0 then mark gx1, oldX, gy1, oldY, startX, startY, boxWidth
          if gx2 < grid.w and gy2 < grid.h then
            mark gx1, gx2, gy1, gy2, startX, startY, boxWidth
            oldX = gx2
            oldY = gy2
          else
            oldX = -1
          end if
        end if
        sleep 1
      loop until mouseB < 1
      if oldX >= 0 then mark gx1, oldX, gy1, oldY, startX, startY, boxWidth
      if gx2 > grid.w-1 or gy2 > grid.h-1 then continue do
      ' check if a correct word was found
      if gy2 = gy1 then
        direc = iif(gx2 > gx1, Direction.right, Direction.left)
        wordLen = abs(gx2-gx1)+1
      elseif gx2 = gx1 then
        direc = iif(gy2 > gy1, Direction.down, Direction.up)
        wordLen = abs(gy2-gy1)+1
      elseif gx2-gx1 = gy2-gy1 then
        direc = iif(gx2 > gx1, Direction.rightdown, Direction.leftup)
        wordLen = abs(gx2-gx1)+1
      elseif gx2-gx1 = gy1-gy2 then
        direc = iif(gx2 > gx1, Direction.rightup, Direction.leftdown)
        wordLen = abs(gx2-gx1)+1
      else
        direc = -1
      end if
      if direc <> -1 then
        dim as integer found = -1
        for i as integer = 0 to ubound(wordlist)
          if gx1 = wordlist(i).x and gy1 = wordlist(i).y then
            if wordList(i).direction = direc andalso wordLength(wordlist(i).value.word) = wordLen then
              found = i
              exit for
            end if
          elseif gx2 = wordlist(i).x and gy2 = wordlist(i).y then
            if wordList(i).direction = (direc+4) mod 8 andalso wordLength(wordlist(i).value.word) = wordLen then
              found = i
              exit for
            end if
          end if
        next
        if found >= 0 andalso wordlist(found).found = 0 then
          line ((gx1+.5)*boxWidth+startX, (gy1+.5)*boxWidth+startY)-((gx2+.5)*boxWidth+startX, (gy2+.5)*boxWidth+startY)
          coord = FTsize(wordList(found).value.translate.get(0), font, 14)
          wordlist(found).found = -1
          line transList, (iif(found < transH\transDist, 0, transW\2), (found mod (transH\transDist))*20+10)-step(coord.x+2, 0)
          dim as FB.Image ptr markImg = imagecreate(coord.x+2, coord.y-5, &h007700)
          put translist, (iif(found < transH\transDist, 0, transW\2), (found mod (transH\transDist))*20), markImg, add
          if showTranslations then
            put (transStartX, transStartY), transList, pset
            ' mark translation of the found word
            line markImg, (0, 0)-step(coord.x+1, coord.y-6), &h000077, bf
            put (transStartX+iif(found < transH\transDist, 0, transW\2), transStartY+(found mod (transH\transDist))*20), markImg, xor
          end if
          imagedestroy markImg
          toFind -= 1
        end if
      end if
    loop
    imagedestroy transList
    if key = chr(255, 107) then return RETVAR.windowClosed
    return RETVAR.ok
  loop
end function

sub CROSSWORD.mark(gx1 as integer, gx2 as integer, gy1 as integer, gy2 as integer, _
                   startX as integer, startY as integer, boxWidth as integer)
  dim as FB.Image ptr grey = imagecreate(boxWidth-1, boxWidth-1, &h333333)
  if gx2 = gx1 then
    for y as integer = gy1 to gy2 step sgn(gy2-gy1+.1)
      put (gx1*boxWidth+startX+1, y*boxWidth+startY+1), grey, xor
    next
  elseif gy2 = gy1 then
    for x as integer = gx1 to gx2 step sgn(gx2-gx1+.1)
      put (x*boxWidth+startX+1, gy1*boxWidth+startY+1), grey, xor
    next
  elseif abs(gx2-gx1) = abs(gy2-gy1) then
    for x as integer = 0 to abs(gx2-gx1)
      put ((gx1+x*sgn(gx2-gx1))*boxWidth+startX+1, (gy1+x*sgn(gy2-gy1))*boxWidth+startY+1), grey, xor
    next
  end if
  imagedestroy grey
end sub
