' module: print all words in a single HTML page or in a page for each lession

namespace EXPORTLIST
  const SORT_LESSION = 1, SORT_ALPHA = 2, SORT_MIX = 3, SINGLE_PAGE = 4, EBOOK = 8, COLORED_OUTPUT = 16 
  declare function callback(exercise as TExercise) as long
  declare function outp(x as integer, y as integer, x2 as integer, h as integer, _
                        word as TWord, opt as integer) as integer
  declare sub printHeader(filenr as integer, lession as integer = -1)
  declare sub printFooter(filenr as integer)
  declare function settings(exercise as TExercise, optional as long = 1) as long
end namespace

globalOptions.add(TExercise("Wortliste exportieren", "full", 0, @EXPORTLIST.callback, 0, @EXPORTLIST.settings))

function EXPORTLIST.callback(exercise as TExercise) as long
  ' At the moment only ebook export is supported!
  
  ' Hard coded settings (will be removed later)
  dim as integer exportType = SORT_LESSION or COLORED_OUTPUT
  ' FOR SINGLE HTML FILE
  dim as string path = "spanish/export", filename = "spanisch.htm"
  ' FOR EBOOK
  'dim as string path = "Calibre/data", filename = "spanisch.htm"
  'dim as string trigger = "Calibre/zipAndMove.sh"

  dim as integer filenumber = freefile, lastLession = 0
  dim as string tempString, obj, article, genus, fem, suffix
  dim as integer span = 0
  dim as TListPoint lp
  dim as TWord w
  open exepath & "/" & path & "/" & filename for output as #filenumber
  printHeader filenumber
  foreach(TListPoint, lp, exercise.fullList.list)
    w = globallist.get(lp.id)
    tempstring = ""
    article = ""
    suffix = ""
    ' FOR EXPORT TO DIFFERENT FILES ONLY
    ' if w.lession > lastLession then
    '   printFooter filenr
    '   close #filenr
    '   open PATH & "/lession" & w.lession & ".htm" for output as #filenr
    '   printHeader filenr, w.lession
    ' end if

    ' FOR EXPORT TO ONE SINGLE FILE ONLY
    if w.lession > lastLession then
      print #filenumber, !"</table>\n"
      print #filenumber, "<h1 id='h" & w.lession & "' class='newpage'>Lektion " _
            & w.lession\100 & "." & w.lession mod 100 & "</h1>"
      print #filenumber, "<table summary='Wortliste'>"
      lastLession = w.lession
    end if

    print #filenumber, "  <tr>"
    print #filenumber, "    <td>";
    fem = w.map.get("f")
    if w.groupname = "noun" then
      genus = w.map.get("genus")
      if len(genus) then article = w.map.get("article")
      select case w.map.get("genus")
        case "m"
          if len(article) = 0 then
            article = iif(w.map.get("num") = "pl", "los", "el")
            if len(fem) then article &= iif(w.map.get("num") = "pl", "/las ", "/la")
          end if
          article &= " "
          if exportType and EXPORTLIST.COLORED_OUTPUT then
            span = 1
            print #filenumber, "<span style='color:blue;'>" & article;
          else
            print #filenumber, article;
          end if
          fem = w.map.get("f")
        case "f"
          if len(article) then
            suffix = " <i>(f)</i>"
          else
            article = iif(w.map.get("num") = "pl", "las", "la")
          end if
          article &= " "
          if exportType and EXPORTLIST.COLORED_OUTPUT then
            span = 1
            print #filenumber, "<span style='color:red;'>" & article;
          else
            print #filenumber, article;
          end if
      end select
    end if
    if len(fem) then
      if left(fem, len(fem)-1) = left(w.word, len(w.word)-1) or left(fem, len(fem)-1) = w.word then
        tempString = "/-" & right(fem, 1)
      elseif left(fem, len(fem)-2) = left(w.word, len(w.word)-2) then
        tempString = "/-" & right(fem, 2)
      else
        tempString = "/" & fem
      end if
    end if
    obj = w.map.get("obj")
    if len(obj) then obj = " <i>" & obj & "</i>"
    print #filenumber, w.word & tempString & obj & iif(span, "</span>", "") & suffix & "&nbsp;&nbsp;";
    tempString = w.map.get("irr")
    if len(tempString) then print #filenumber, "<br />&nbsp;&nbsp;&nbsp;<i>(" & tempString & ")</i>";
    print #filenumber, "</td>"
    print #filenumber, "    <td>" & w.translate.get(0);
    for i as integer = 1 to w.translate.size-1
      print #filenumber, ", " & w.translate.get(i);
    next
    print #filenumber, "</td>"
    print #filenumber, "  </tr>"
  nexteach
  printFooter(filenumber)
  close filenumber

  ' ZIP EBOOK AND MOVE TO CALIBRE LIBRARY
  'shell exepath & "/" & trigger
  'message "Das E-Book wurde erstellt und in|die Calibre-Bibliothek kopiert.",, 1
  message "Die Export-Datei wurde erstellt und liegt im Ordner spanish/export",, 1

  return -1
end function

sub EXPORTLIST.printHeader(filenr as integer, lession as integer = -1)
  print #filenr, "<!DOCTYPE html>"
  print #filenr, "<html xmlns='http://www.w3.org/1999/xhtml'>"
  print #filenr, "<head>"
  print #filenr, "  <title>Spanisch-W&ouml;rter";
  if lession = 0 then
    print #filenr, ", Lektion 0";
  elseif lession > 0 then
    print #filenr, ", Lektion " & lession\100 & "." & lession mod 100;
  end if
  print #filenr, "</title>"
  print #filenr, "  <meta http-equiv='content-type' content='text/html;charset=utf-8' />"
  print #filenr, "  <style type='text/css'>"
  print #filenr, "    td { vertical-align:top; }"
  print #filenr, "  </style>"
  print #filenr, "</head>"
  print #filenr, "<body>"
  print #filenr, "<div>"
  if lession = 0 then
    print #filenr, "<h1 id='h000'>Lektion 0</h1>"
  elseif lession > 0 then
    print #filenr, "<h1 id='h" & lession & "'>Lektion " & lession\100 & "." & lession mod 100 & "</h1>"
  end if
  print #filenr, "<table summary='Wortliste'>"
end sub

sub EXPORTLIST.printFooter(filenr as integer)
  print #filenr, "</table>"
  print #filenr, "</div>"
  print #filenr, "</body>"
  print #filenr, "</html>"
end sub

function EXPORTLIST.settings(exercise as TExercise, optional as long = 1) as long
  return -1
end function

'open PATH & "/stil.css" for output as #outfile
'print #outfile, "td { vertical-align:top; }"
'print #outfile, ".newpage { page-break-before:always; display:block; }"
'close #outfile
